【LeetCode】1.两数之和

问题描述

给定一个整数数组和一个目标值,找出数组中和为目标值的 两个 数。
你可以假设每个输入只对应一种答案,且同样的元素不能被重复利用。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

题解

方法一、暴力法

循环就完事了

function twoSum(nums, target) {
  for (let i = 0, length = nums.length; i < length; i++) {
    for(let j = i + 1; j < length; j++) {
      let a = nums[i], b = nums[j]
      if (a + b == target) {
        return [i, j];
      }
    }
  }
}

时间复杂度:O(n²)
空间复杂度:O(1)

方法二、哈希表

第一遍遍历创建哈希表,第二次遍历检查哈希表中是否存在[target-nums[i]]的值,当然不能是本身

function twoSum2 (nums, target) {
  let map = new Map()
  for(let i = 0, length = nums.length; i < length; i++) {
    map.set(nums[i], i)
  }
  for (let i = 0, length = nums.length; i < length; i++) {
    const temp = target - nums[i]
    if (map.has(temp) && i != map.get(temp)) return [i, map.get(temp)]
  }
}

时间复杂度:O(n)
空间复杂度:O(n)

方法三、哈希表(一次遍历)

边遍历边检查哈希表中是否存在[target-nums[i]],如果不存在则在检查之后j将值及序号存入哈希表

function twoSum3 (nums, target) {
  let map = new Map()
  for(let i = 0, length = nums.length; i < length; i++) {
    const temp = target - nums[i]
    if (map.has(temp)) return [i, map.get(temp)]
    map.set(nums[i], i)
  }
}

时间复杂度:O(n)
空间复杂度:O(n)

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

MAXLZ

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值